--- old/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
+++ new/usr/src/uts/common/io/fibre-channel/fca/qlc/ql_api.c	Mon Aug  5 17:28:23 2019
@@ -16728,60 +17818,12 @@
 
 	EL(ha, "using FIXED interupts\n");
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (DDI_SUCCESS);
 }
 
 /*
- * ql_disable_intr
- *	Disables interrupts
- *
- * Input:
- *	ha = adapter state pointer.
- *
- * Returns:
- *
- * Context:
- *	Kernel context.
- */
-static void
-ql_disable_intr(ql_adapter_state_t *ha)
-{
-	uint32_t	i, rval;
-
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
-
-	if (!(ha->iflags & IFLG_INTR_AIF)) {
-
-		/* Disable legacy interrupts */
-		(void) ddi_remove_intr(ha->dip, 0, ha->iblock_cookie);
-
-	} else if ((ha->intr_cap & DDI_INTR_FLAG_BLOCK) &&
-	    (ha->iflags & (IFLG_INTR_MSI | IFLG_INTR_MSIX))) {
-
-		/* Remove AIF block interrupts (MSI) */
-		if ((rval = ddi_intr_block_disable(ha->htable, ha->intr_cnt))
-		    != DDI_SUCCESS) {
-			EL(ha, "failed intr block disable, rval=%x\n", rval);
-		}
-
-	} else {
-
-		/* Remove AIF non-block interrupts (fixed).  */
-		for (i = 0; i < ha->intr_cnt; i++) {
-			if ((rval = ddi_intr_disable(ha->htable[i])) !=
-			    DDI_SUCCESS) {
-				EL(ha, "failed intr disable, intr#=%xh, "
-				    "rval=%xh\n", i, rval);
-			}
-		}
-	}
-
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-}
-
-/*
  * ql_release_intr
  *	Releases aif legacy interrupt resources
  *
@@ -16796,43 +17838,52 @@
 static void
 ql_release_intr(ql_adapter_state_t *ha)
 {
-	int32_t 	i;
+	int32_t	i, x;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (!(ha->iflags & IFLG_INTR_AIF)) {
-		QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-		return;
-	}
+		ddi_remove_intr(ha->dip, 0, ha->iblock_cookie);
+	} else {
+		ha->iflags &= ~(IFLG_INTR_AIF);
+		if (ha->htable != NULL && ha->hsize > 0) {
+			i = x = (int32_t)ha->hsize /
+			    (int32_t)sizeof (ddi_intr_handle_t);
+			if (ha->intr_cap & DDI_INTR_FLAG_BLOCK) {
+				(void) ddi_intr_block_disable(ha->htable,
+				    ha->intr_cnt);
+			} else {
+				while (i-- > 0) {
+					if (ha->htable[i] == 0) {
+						EL(ha, "htable[%x]=0h\n", i);
+						continue;
+					}
 
-	ha->iflags &= ~(IFLG_INTR_AIF);
-	if (ha->htable != NULL && ha->hsize > 0) {
-		i = (int32_t)ha->hsize / (int32_t)sizeof (ddi_intr_handle_t);
-		while (i-- > 0) {
-			if (ha->htable[i] == 0) {
-				EL(ha, "htable[%x]=0h\n", i);
-				continue;
+					(void) ddi_intr_disable(ha->htable[i]);
+				}
 			}
 
-			(void) ddi_intr_disable(ha->htable[i]);
-
-			if (i < ha->intr_cnt) {
-				(void) ddi_intr_remove_handler(ha->htable[i]);
+			i = x;
+			while (i-- > 0) {
+				if (i < ha->intr_cnt) {
+					(void) ddi_intr_remove_handler(
+					    ha->htable[i]);
+				}
+				(void) ddi_intr_free(ha->htable[i]);
 			}
 
-			(void) ddi_intr_free(ha->htable[i]);
-		}
+			ha->intr_cnt = 0;
+			ha->intr_cap = 0;
 
-		kmem_free(ha->htable, ha->hsize);
-		ha->htable = NULL;
+			kmem_free(ha->htable, ha->hsize);
+			ha->htable = NULL;
+			ha->hsize = 0;
+		}
 	}
 
-	ha->hsize = 0;
-	ha->intr_cnt = 0;
-	ha->intr_pri = 0;
-	ha->intr_cap = 0;
+	ha->intr_pri = NULL;
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -16854,15 +17905,17 @@
 static int
 ql_legacy_intr(ql_adapter_state_t *ha)
 {
-	int	rval = DDI_SUCCESS;
+	int	rval;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
-	/* Setup mutexes */
-	if (ql_init_mutex(ha) != DDI_SUCCESS) {
-		EL(ha, "failed, mutex init\n");
-		return (DDI_FAILURE);
+	/* Get iblock cookies to initialize mutexes */
+	if ((rval = ddi_get_iblock_cookie(ha->dip, 0, &ha->iblock_cookie)) !=
+	    DDI_SUCCESS) {
+		EL(ha, "failed, get_iblock: %xh\n", rval);
+		return (rval);
 	}
+	ha->intr_pri = (void *)ha->iblock_cookie;
 
 	/* Setup standard/legacy interrupt handler */
 	if (ddi_add_intr(ha->dip, (uint_t)0, &ha->iblock_cookie,
@@ -16869,17 +17922,17 @@
 	    (ddi_idevice_cookie_t *)0, ql_isr, (caddr_t)ha) != DDI_SUCCESS) {
 		cmn_err(CE_WARN, "%s(%d): Failed to add legacy interrupt",
 		    QL_NAME, ha->instance);
-		ql_destroy_mutex(ha);
-		rval = DDI_FAILURE;
+		return (rval);
 	}
+	ha->iflags |= IFLG_INTR_LEGACY;
 
-	if (rval == DDI_SUCCESS) {
-		ha->iflags |= IFLG_INTR_LEGACY;
+	/* Setup mutexes */
+	if ((rval = ql_init_mutex(ha)) != DDI_SUCCESS) {
+		EL(ha, "failed, mutex init ret=%xh\n", rval);
+		ql_release_intr(ha);
+	} else {
 		EL(ha, "using legacy interrupts\n");
 	}
-
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-
 	return (rval);
 }
 
@@ -16899,64 +17952,43 @@
 static int
 ql_init_mutex(ql_adapter_state_t *ha)
 {
-	int	ret;
-	void	*intr;
+	QL_PRINT_3(ha, "started\n");
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
-
-	if (ha->iflags & IFLG_INTR_AIF) {
-		intr = (void *)(uintptr_t)ha->intr_pri;
-	} else {
-		/* Get iblock cookies to initialize mutexes */
-		if ((ret = ddi_get_iblock_cookie(ha->dip, 0,
-		    &ha->iblock_cookie)) != DDI_SUCCESS) {
-			EL(ha, "failed, get_iblock: %xh\n", ret);
-			return (DDI_FAILURE);
-		}
-		intr = (void *)ha->iblock_cookie;
-	}
-
 	/* mutexes to protect the adapter state structure. */
-	mutex_init(&ha->mutex, NULL, MUTEX_DRIVER, intr);
+	mutex_init(&ha->mutex, NULL, MUTEX_DRIVER, ha->intr_pri);
 
-	/* mutex to protect the ISP response ring. */
-	mutex_init(&ha->intr_mutex, NULL, MUTEX_DRIVER, intr);
+	/* mutex to protect the ISP request ring. */
+	mutex_init(&ha->req_ring_mutex, NULL, MUTEX_DRIVER, ha->intr_pri);
 
+	/* I/O completion queue protection. */
+	mutex_init(&ha->comp_q_mutex, NULL, MUTEX_DRIVER, ha->intr_pri);
+	cv_init(&ha->cv_comp_thread, NULL, CV_DRIVER, NULL);
+
 	/* mutex to protect the mailbox registers. */
-	mutex_init(&ha->mbx_mutex, NULL, MUTEX_DRIVER, intr);
+	mutex_init(&ha->mbx_mutex, NULL, MUTEX_DRIVER, ha->intr_pri);
 
-	/* power management protection */
-	mutex_init(&ha->pm_mutex, NULL, MUTEX_DRIVER, intr);
-
 	/* Mailbox wait and interrupt conditional variable. */
 	cv_init(&ha->cv_mbx_wait, NULL, CV_DRIVER, NULL);
 	cv_init(&ha->cv_mbx_intr, NULL, CV_DRIVER, NULL);
 
-	/* mutex to protect the ISP request ring. */
-	mutex_init(&ha->req_ring_mutex, NULL, MUTEX_DRIVER, intr);
+	/* power management protection */
+	mutex_init(&ha->pm_mutex, NULL, MUTEX_DRIVER, ha->intr_pri);
 
 	/* Unsolicited buffer conditional variable. */
+	mutex_init(&ha->ub_mutex, NULL, MUTEX_DRIVER, ha->intr_pri);
 	cv_init(&ha->cv_ub, NULL, CV_DRIVER, NULL);
 
-	mutex_init(&ha->ub_mutex, NULL, MUTEX_DRIVER, intr);
-	mutex_init(&ha->cache_mutex, NULL, MUTEX_DRIVER, intr);
+	/* mutex to protect task daemon context. */
+	mutex_init(&ha->task_daemon_mutex, NULL, MUTEX_DRIVER, ha->intr_pri);
+	cv_init(&ha->cv_task_daemon, NULL, CV_DRIVER, NULL);
 
 	/* Suspended conditional variable. */
 	cv_init(&ha->cv_dr_suspended, NULL, CV_DRIVER, NULL);
 
-	/* mutex to protect task daemon context. */
-	mutex_init(&ha->task_daemon_mutex, NULL, MUTEX_DRIVER, intr);
-
-	/* Task_daemon thread conditional variable. */
-	cv_init(&ha->cv_task_daemon, NULL, CV_DRIVER, NULL);
-
-	/* mutex to protect diag port manage interface */
-	mutex_init(&ha->portmutex, NULL, MUTEX_DRIVER, intr);
-
 	/* mutex to protect per instance f/w dump flags and buffer */
-	mutex_init(&ha->dump_mutex, NULL, MUTEX_DRIVER, intr);
+	mutex_init(&ha->dump_mutex, NULL, MUTEX_DRIVER, ha->intr_pri);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (DDI_SUCCESS);
 }
@@ -16976,25 +18008,24 @@
 static void
 ql_destroy_mutex(ql_adapter_state_t *ha)
 {
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	mutex_destroy(&ha->dump_mutex);
-	mutex_destroy(&ha->portmutex);
+	cv_destroy(&ha->cv_dr_suspended);
 	cv_destroy(&ha->cv_task_daemon);
 	mutex_destroy(&ha->task_daemon_mutex);
-	cv_destroy(&ha->cv_dr_suspended);
-	mutex_destroy(&ha->cache_mutex);
-	mutex_destroy(&ha->ub_mutex);
 	cv_destroy(&ha->cv_ub);
-	mutex_destroy(&ha->req_ring_mutex);
+	mutex_destroy(&ha->ub_mutex);
+	mutex_destroy(&ha->pm_mutex);
 	cv_destroy(&ha->cv_mbx_intr);
 	cv_destroy(&ha->cv_mbx_wait);
-	mutex_destroy(&ha->pm_mutex);
 	mutex_destroy(&ha->mbx_mutex);
-	mutex_destroy(&ha->intr_mutex);
+	cv_destroy(&ha->cv_comp_thread);
+	mutex_destroy(&ha->comp_q_mutex);
+	mutex_destroy(&ha->req_ring_mutex);
 	mutex_destroy(&ha->mutex);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
@@ -17024,15 +18055,15 @@
 	int8_t			module[128];
 	int8_t			fw_version[128];
 	uint32_t		rval = QL_SUCCESS;
-	caddr_t			code, code02;
+	caddr_t			code, code02, code03;
 	uint8_t			*p_ucfw;
 	uint16_t		*p_usaddr, *p_uslen;
 	uint32_t		*p_uiaddr, *p_uilen, *p_uifw;
-	uint32_t		*p_uiaddr02, *p_uilen02;
+	uint32_t		*p_uiaddr02, *p_uilen02, *p_uilen03;
 	struct fw_table		*fwt;
 	extern struct fw_table	fw_table[];
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (ha->fw_module != NULL) {
 		EL(ha, "%x f/w module %d.%02d.%02d is already loaded\n",
@@ -17105,7 +18136,9 @@
 
 	case 0x2400:
 	case 0x2500:
+	case 0x2700:
 	case 0x8100:
+	case 0x8301fc:
 
 		if ((code = ddi_modsym(ha->fw_module, "risc_code01",
 		    NULL)) == NULL) {
@@ -17140,6 +18173,24 @@
 		}
 
 		if (rval == QL_SUCCESS) {
+			if (ha->fw_class == 0x2700) {
+				if ((code03 = ddi_modsym(ha->fw_module,
+				    "tmplt_code01", NULL)) == NULL) {
+					EL(ha, "failed, f/w module %d "
+					    "tmplt_code01 symbol\n", module);
+				} else if ((p_uilen03 = ddi_modsym(
+				    ha->fw_module, "tmplt_code_length01",
+				    NULL)) == NULL) {
+					code03 = NULL;
+					EL(ha, "failed, f/w module %d "
+					    "tmplt_code_length01 symbol\n",
+					    module);
+				}
+				ha->risc_fw[2].code = code03;
+				if ((ha->risc_fw[2].code = code03) != NULL) {
+					ha->risc_fw[2].length = *p_uilen03;
+				}
+			}
 			ha->risc_fw[0].code = code;
 			ha->risc_fw[0].addr = *p_uiaddr;
 			ha->risc_fw[0].length = *p_uilen;
@@ -17182,14 +18233,10 @@
 			    "mismatch for %x: driver-%s module-%s", QL_NAME,
 			    ha->instance, ha->fw_class, fwt->fw_version,
 			    fw_version);
-
-			ha->cfg_flags |= CFG_FW_MISMATCH;
-		} else {
-			ha->cfg_flags &= ~CFG_FW_MISMATCH;
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -17211,7 +18258,7 @@
 {
 	ql_adapter_state_t	*vha;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	TASK_DAEMON_LOCK(ha);
 	for (vha = ha->pha; vha != NULL; vha = vha->vp_next) {
@@ -17224,83 +18271,60 @@
 	ha->pha->task_daemon_flags |= flags & LOOP_DOWN;
 	TASK_DAEMON_UNLOCK(ha);
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 }
 
 /*
- * ql_el_trace_desc_ctor - Construct an extended logging trace descriptor.
+ * ql_el_trace_alloc - Construct an extended logging trace descriptor.
  *
  * Input:	Pointer to the adapter state structure.
- * Returns:	Success or Failure.
  * Context:	Kernel context.
  */
-int
-ql_el_trace_desc_ctor(ql_adapter_state_t *ha)
+void
+ql_el_trace_alloc(ql_adapter_state_t *ha)
 {
-	int	rval = DDI_SUCCESS;
+	ql_trace_entry_t	*entry;
+	size_t			maxsize;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	ha->ql_trace_desc =
+	    (ql_trace_desc_t *)kmem_zalloc(
+	    sizeof (ql_trace_desc_t), KM_SLEEP);
 
-	ha->el_trace_desc =
-	    (el_trace_desc_t *)kmem_zalloc(sizeof (el_trace_desc_t), KM_SLEEP);
+	/* ql_log_entries could be adjusted in /etc/system */
+	maxsize = ql_log_entries * sizeof (ql_trace_entry_t);
+	entry = kmem_zalloc(maxsize, KM_SLEEP);
 
-	if (ha->el_trace_desc == NULL) {
-		cmn_err(CE_WARN, "%s(%d): can't construct trace descriptor",
-		    QL_NAME, ha->instance);
-		rval = DDI_FAILURE;
-	} else {
-		ha->el_trace_desc->next		= 0;
-		ha->el_trace_desc->trace_buffer =
-		    (char *)kmem_zalloc(EL_TRACE_BUF_SIZE, KM_SLEEP);
+	mutex_init(&ha->ql_trace_desc->mutex, NULL,
+	    MUTEX_DRIVER, NULL);
 
-		if (ha->el_trace_desc->trace_buffer == NULL) {
-			cmn_err(CE_WARN, "%s(%d): can't get trace buffer",
-			    QL_NAME, ha->instance);
-			kmem_free(ha->el_trace_desc, sizeof (el_trace_desc_t));
-			rval = DDI_FAILURE;
-		} else {
-			ha->el_trace_desc->trace_buffer_size =
-			    EL_TRACE_BUF_SIZE;
-			mutex_init(&ha->el_trace_desc->mutex, NULL,
-			    MUTEX_DRIVER, NULL);
-		}
-	}
+	ha->ql_trace_desc->trace_buffer = entry;
+	ha->ql_trace_desc->trace_buffer_size = maxsize;
+	ha->ql_trace_desc->nindex = 0;
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-
-	return (rval);
+	ha->ql_trace_desc->nentries = ql_log_entries;
+	ha->ql_trace_desc->start = ha->ql_trace_desc->end = 0;
+	ha->ql_trace_desc->csize = 0;
+	ha->ql_trace_desc->count = 0;
 }
 
 /*
- * ql_el_trace_desc_dtor - Destroy an extended logging trace descriptor.
+ * ql_el_trace_dealloc - Destroy an extended logging trace descriptor.
  *
  * Input:	Pointer to the adapter state structure.
- * Returns:	Success or Failure.
  * Context:	Kernel context.
  */
-int
-ql_el_trace_desc_dtor(ql_adapter_state_t *ha)
+void
+ql_el_trace_dealloc(ql_adapter_state_t *ha)
 {
-	int	rval = DDI_SUCCESS;
-
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
-
-	if (ha->el_trace_desc == NULL) {
-		cmn_err(CE_WARN, "%s(%d): can't destroy el trace descriptor",
-		    QL_NAME, ha->instance);
-		rval = DDI_FAILURE;
-	} else {
-		if (ha->el_trace_desc->trace_buffer != NULL) {
-			kmem_free(ha->el_trace_desc->trace_buffer,
-			    ha->el_trace_desc->trace_buffer_size);
+	if (ha->ql_trace_desc != NULL) {
+		if (ha->ql_trace_desc->trace_buffer != NULL) {
+			kmem_free(ha->ql_trace_desc->trace_buffer,
+			    ha->ql_trace_desc->trace_buffer_size);
 		}
-		mutex_destroy(&ha->el_trace_desc->mutex);
-		kmem_free(ha->el_trace_desc, sizeof (el_trace_desc_t));
+		mutex_destroy(&ha->ql_trace_desc->mutex);
+		kmem_free(ha->ql_trace_desc,
+		    sizeof (ql_trace_desc_t));
 	}
-
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
-
-	return (rval);
 }
 
 /*
@@ -17353,21 +18377,28 @@
 }
 
 /*
- * ql_els_24xx_mbox_cmd_iocb - els request indication.
+ * ql_els_24xx_iocb
+ * 	els request indication.
  *
- * Input:	ha = adapter state pointer.
- *		srb = scsi request block pointer.
- *		arg = els passthru entry iocb pointer.
+ * Input:
+ *	ha:	adapter state pointer.
+ *	req_q:	request queue structure pointer.
+ *	srb:	scsi request block pointer.
+ *      arg:	els passthru entry iocb pointer.
+ *
  * Returns:
+ *
  * Context:	Kernel context.
  */
 void
-ql_els_24xx_iocb(ql_adapter_state_t *ha, ql_srb_t *srb, void *arg)
+ql_els_24xx_iocb(ql_adapter_state_t *ha, ql_request_q_t *req_q, ql_srb_t *srb,
+    void *arg)
 {
 	els_descriptor_t	els_desc;
 
 	/* Extract the ELS information */
-	ql_fca_isp_els_request(ha, (fc_packet_t *)srb->pkt, &els_desc);
+	ql_fca_isp_els_request(ha, req_q, (fc_packet_t *)srb->pkt,
+	    &els_desc);
 
 	/* Construct the passthru entry */
 	ql_isp_els_request_ctor(&els_desc, (els_passthru_entry_t *)arg);
@@ -17377,18 +18408,22 @@
 }
 
 /*
- * ql_fca_isp_els_request - Extract into an els descriptor the info required
- *			    to build an els_passthru iocb from an fc packet.
+ * ql_fca_isp_els_request
+ *	Extract into an els descriptor the info required
+ *	to build an els_passthru iocb from an fc packet.
  *
- * Input:	ha = adapter state pointer.
- *		pkt = fc packet pointer
- *		els_desc = els descriptor pointer
- * Returns:
- * Context:	Kernel context.
+ * Input:
+ *	ha:		adapter state pointer.
+ *	req_q:		request queue structure pointer.
+ *	pkt:		fc packet pointer
+ *	els_desc:	els descriptor pointer
+ *
+ * Context:
+ *	Kernel context.
  */
 static void
-ql_fca_isp_els_request(ql_adapter_state_t *ha, fc_packet_t *pkt,
-    els_descriptor_t *els_desc)
+ql_fca_isp_els_request(ql_adapter_state_t *ha, ql_request_q_t *req_q,
+    fc_packet_t *pkt, els_descriptor_t *els_desc)
 {
 	ls_code_t	els;
 
@@ -17397,7 +18432,7 @@
 
 	els_desc->els = els.ls_code;
 
-	els_desc->els_handle = ha->hba_buf.acc_handle;
+	els_desc->els_handle = req_q->req_ring.acc_handle;
 	els_desc->d_id.b24 = pkt->pkt_cmd_fhdr.d_id;
 	els_desc->s_id.b24 = pkt->pkt_cmd_fhdr.s_id;
 	/* if n_port_handle is not < 0x7d use 0 */
@@ -17474,7 +18509,7 @@
 	ddi_put32(els_desc->els_handle, &els_entry->xmt_payld_data_bcnt,
 	    els_desc->cmd_byte_count);
 	/* Load transmit data segments and count. */
-	ptr32 = (uint32_t *)&els_entry->xmt_dseg_0_address;
+	ptr32 = (uint32_t *)&els_entry->dseg;
 	ddi_put16(els_desc->els_handle, &els_entry->xmt_dseg_count, 1);
 	ddi_put32(els_desc->els_handle, ptr32++, els_desc->tx_dsd.addr[0]);
 	ddi_put32(els_desc->els_handle, ptr32++, els_desc->tx_dsd.addr[1]);
@@ -17621,7 +18656,7 @@
 ql_n_port_plogi(ql_adapter_state_t *ha)
 {
 	int		rval;
-	ql_tgt_t	*tq;
+	ql_tgt_t	*tq = NULL;
 	ql_head_t done_q = { NULL, NULL };
 
 	rval = QL_SUCCESS;
@@ -17642,7 +18677,7 @@
 			    ha->n_port->n_port_handle, tq);
 		}
 		if (done_q.first != NULL) {
-			ql_done(done_q.first);
+			ql_done(done_q.first, B_FALSE);
 		}
 	}
 	return (rval);
@@ -17660,6 +18695,7 @@
  *   if first > second  return  1
  *   if first < second  return -1
  */
+/* ARGSUSED */
 int
 ql_wwn_cmp(ql_adapter_state_t *ha, la_wwn_t *first, la_wwn_t *second)
 {
@@ -17666,10 +18702,6 @@
 	la_wwn_t t1, t2;
 	int rval;
 
-	EL(ha, "WWPN=%08x%08x\n",
-	    BE_32(first->i_wwn[0]), BE_32(first->i_wwn[1]));
-	EL(ha, "WWPN=%08x%08x\n",
-	    BE_32(second->i_wwn[0]), BE_32(second->i_wwn[1]));
 	/*
 	 * Fibre Channel protocol is big endian, so compare
 	 * as big endian values
@@ -17699,45 +18731,6 @@
 }
 
 /*
- * ql_wait_for_td_stop
- *	Wait for task daemon to stop running.  Internal command timeout
- *	is approximately 30 seconds, so it may help in some corner
- *	cases to wait that long
- *
- * Input:
- *	ha = adapter state pointer.
- *
- * Returns:
- *	DDI_SUCCESS or DDI_FAILURE.
- *
- * Context:
- *	Kernel context.
- */
-
-static int
-ql_wait_for_td_stop(ql_adapter_state_t *ha)
-{
-	int	rval = DDI_FAILURE;
-	UINT16	wait_cnt;
-
-	for (wait_cnt = 0; wait_cnt < 3000; wait_cnt++) {
-		/* The task daemon clears the stop flag on exit. */
-		if (ha->task_daemon_flags & TASK_DAEMON_STOP_FLG) {
-			if (ha->cprinfo.cc_events & CALLB_CPR_START ||
-			    ddi_in_panic()) {
-				drv_usecwait(10000);
-			} else {
-				delay(drv_usectohz(10000));
-			}
-		} else {
-			rval = DDI_SUCCESS;
-			break;
-		}
-	}
-	return (rval);
-}
-
-/*
  * ql_nvram_cache_desc_ctor - Construct an nvram cache descriptor.
  *
  * Input:	Pointer to the adapter state structure.
@@ -17749,7 +18742,7 @@
 {
 	int	rval = DDI_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	ha->nvram_cache =
 	    (nvram_cache_desc_t *)kmem_zalloc(sizeof (nvram_cache_desc_t),
@@ -17760,7 +18753,7 @@
 		    " descriptor", QL_NAME, ha->instance);
 		rval = DDI_FAILURE;
 	} else {
-		if (CFG_IST(ha, CFG_CTRL_24258081)) {
+		if (CFG_IST(ha, CFG_ISP_FW_TYPE_2)) {
 			ha->nvram_cache->size = sizeof (nvram_24xx_t);
 		} else {
 			ha->nvram_cache->size = sizeof (nvram_t);
@@ -17775,13 +18768,11 @@
 			ha->nvram_cache = 0;
 			rval = DDI_FAILURE;
 		} else {
-			mutex_init(&ha->nvram_cache->mutex, NULL,
-			    MUTEX_DRIVER, NULL);
 			ha->nvram_cache->valid = 0;
 		}
 	}
 
-	QL_PRINT_3(CE_CONT, "(%d): done\n", ha->instance);
+	QL_PRINT_3(ha, "done\n");
 
 	return (rval);
 }
@@ -17798,7 +18789,7 @@
 {
 	int	rval = DDI_SUCCESS;
 
-	QL_PRINT_3(CE_CONT, "(%d): started\n", ha->instance);
+	QL_PRINT_3(ha, "started\n");
 
 	if (ha->nvram_cache == NULL) {
 		cmn_err(CE_WARN, "%s(%d): can't destroy nvram descriptor",
